SuperStrict
AppTitle = "GDef"
Global gfx_w:Int = 786
Global gfx_h:Int = 786
Graphics(gfx_w, gfx_h, 0, 60)
AutoMidHandle(True)
SeedRnd MilliSecs()
Local Frametimer:TTimer = TTimer.Create(59)

Global mx:Int, my:Int, mh:Int[4], key:Int[256], ms:Int
Global mx_old:Int, my_old:Int, mspeed:Int, varianz:Int=20
Global time:Int, tlen:Int = 300
SetImageFont(LoadImageFont(getenv_("windir") + "/fonts/" + "Arial.ttf", 22))

SetColor(0, 0, 0)
SetClsColor(255, 255, 255)
SetBlend(ALPHABLEND)

'* O, R
TMot.Create(, [ TLine.Do(0), TLine.Do(90) ], green)
'* L, U
TMot.Create(, [ TLine.Do(270), TLine.Do(180) ], green)

'* R, O
TMot.Create(, [ TLine.Do(90), TLine.Do(0) ], blue)
'* U, L
TMot.Create(, [ TLine.Do(180), TLine.Do(270) ], blue)

'* R, U
TMot.Create(, [ TLine.Do(90), TLine.Do(180) ], yellow)
'* O, L
TMot.Create(, [ TLine.Do(0), TLine.Do(270) ], yellow)

'* L, O
TMot.Create(, [ TLine.Do(270), TLine.Do(0) ], purpur)
'* U, R
TMot.Create(, [ TLine.Do(180), TLine.Do(90) ], purpur)

'* RO, R
TMot.Create(, [ TLine.Do(45), TLine.Do(90) ], random)
'* L, LU
TMot.Create(, [ TLine.Do(270), TLine.Do(225) ], random)

Repeat
	Cls
	
	ms = MilliSecs()
	mx_old = mx
	my_old = my
	mx = MouseX()
	my = MouseY()
	mspeed = Dist(mx_old-mx, my_old-my)

	if mspeed > 5 Then 
		time = ms + tlen
		if TPos.list.count() = 0 Then 
			TPos.Create(mx,my)
		Elseif TPos.list.count() > 0 Then

			'* weicht die letzte linie um [varianz] Grad ab?
			local last:TPos = TPos(TPos.list.Last())
			Local w1:Int = Angle(last.x-mx, last.y-my)
			Local w2:Int = Angle(mx_old-mx, my_old-my)
			Local bigger:Int = max(w1, w2)
			Local smaller:Int = min(w1, w2) 
			Local diff:Int = abs(bigger - smaller)
			if (diff > varianz) then TPos.Create(mx,my)

		endif
	Else
		if TPos.list.count() > 0 Then
			local last:TPos = TPos(TPos.list.Last())
			if (Dist(last.x-mx, last.y-my)) > 32 then TPos.Create(mx,my)
		endif
		if time < ms then
			TPos.Check()
			TPos.Clear()
		endif
	endif

	For Local i:Int = 1 Until mh.length
		mh[i] = MouseHit(i)
	Next
	For Local i:Int = 0 Until key.length
		key[i] = KeyHit(i)
	Next

	drawtext("Speed: "+mspeed,10,10)
	drawtext("Points: "+TPos.list.count(),10,30)
	'drawtext("time: "+(time - ms),10,50)

	TPos.Draw()
	
	Flip(0)
	Frametimer.Wait()
	If KeyHit(KEY_ESCAPE) Or AppTerminate() Then End
Forever
End 

Function Dist:Int(_x:Int, _y:Int)
	return sqr(_x*_x+_y*_y)
EndFunction

Function Angle:Int(_x:Int, _y:Int)
	return (atan2(_y, _x) + 270 + 360) mod 360
EndFunction

Function green()
	SetClsColor(0, 255, 0)
EndFunction

Function blue()
	SetClsColor(0, 0, 255)
EndFunction

Function yellow()
	SetClsColor(255, 255, 0)
EndFunction

Function purpur()
	SetClsColor(128, 0, 128)
EndFunction

Function random()
	Local r:Byte = (rand(0,8)*32)-1
	Local g:Byte = (rand(0,8)*32)-1
	Local b:Byte = (rand(0,8)*32)-1
	SetClsColor(r, g, b)
EndFunction

Type TPos
	Field x:Int, y:Int
	Global list:TList = new TList

	Function Create:TPos(_x:Int, _y:Int, add:Int = true)
		Local o:TPos = new TPos
			o.x = _x
			o.y = _y
			if add then list.AddLast(o)
		return o
	EndFunction

	Function Check()
		TPos.Reduce()
		if TPos.list.count() < 3 then return
		Local l:TPos, lines:TList = new TList
		for local p:TPos = eachin TPos.list
			if l then
				Drawline(l.x, l.y, p.x, p.y)
				lines.AddLast( TLine.Create(l.x, l.y, p.x, p.y) )
			endif
			l = p
		next
		TMot.Activate(lines)
	EndFunction

	Function Reduce()
		Local reduced:Byte, l:TPos, newlist:TList
		reduced = false
		newlist = new TList
		for local p:TPos = eachin TPos.list
			if l then
				if Dist(l.x-p.x, l.y-p.y) < 96 then 
					newlist.AddLast( TPos.Create((l.x+p.x)/2, (l.y+p.y)/2, false) ) 
					reduced = True
				Else
					newlist.AddLast(l)
				endif
			endif
			l = p
		next
		if reduced then 
			newlist.AddLast( TPos(TPos.list.Last()) ) '* Save last point
			TPos.list = newlist
		endif
	EndFunction

	Function Draw()
		for local p:TPos = eachin TPos.list
			drawtext("+",p.x,p.y)
		next
	EndFunction

	Function Clear()
		TPos.list.Clear()
	EndFunction

EndType

Type TLine
	Field x1:Int, y1:Int
	field x2:Int, y2:Int
	Field l:Int, w:Int

	Function Create:TLine(_x1:Int,_y1:Int,_x2:Int,_y2:Int)
		Local o:TLine = new TLine
			o.x1 = _x1
			o.y1 = _y1
			o.x2 = _x2
			o.y2 = _y2
			o.Calc()
		return o
	EndFunction

	Function Do:TLine(_w:Int)
		Local o:TLine = new TLine
			o.w = _w
		return o
	EndFunction

	Method Calc()
		l = Dist(x1-x2,y1-y2)
		w = Angle(x1-x2, y1-y2)
	EndMethod

EndType

Type TMot
	Field name:String
	Field lines:TLine[]
	field func()

	Global list:TList = new TList
	Function Create:TMot(_name:String="", _lines:TLine[], _f())
		Local o:TMot = new TMot
			o.name = _name
			o.lines = _lines
			o.func = _f
			TMot.list.AddLast(o)
		return o
	EndFunction

	Function Activate:Int( _lines:TList )
		for local m:TMot = eachin TMot.list
			if m.lines.length = _lines.count() then
				Local l1:TLine, l2:TLine, i:Int=0, L:Object[] = _lines.toArray(), a:Int=true
				for l1 = eachin m.lines
					l2 = TLine(L[i])
					Local bigger:Int = max(l1.w, l2.w)
					Local smaller:Int = min(l1.w, l2.w) 
					Local diff:Int = abs(bigger - smaller)
					if (2*diff > varianz) then 
						a=false
						exit
					endif
					i:+1
				next
				if a then 
					m.func()
					return true
				endif
			endif
		next
		return false
	EndFunction

EndType
